package org.briarproject.bramble.api.contact;

import org.briarproject.bramble.api.identity.Author;
import org.briarproject.bramble.api.identity.AuthorId;
import org.briarproject.bramble.api.nullsafety.NotNullByDefault;

@NotNullByDefault
public interface ContactFactory {

	static Contact createContact(ContactId c, Author author,
			AuthorId localAuthorId, boolean verified, boolean active,
			ContactType type) {
		switch (type) {
			case CONTACT:
				return new Contact(c, author, localAuthorId, verified, active);
			case PRIVATE_MAILBOX:
				return new PrivateMailbox(c, author, localAuthorId, verified,
						active);
			case MAILBOX_OWNER:
				return new MailboxOwner(c, author, localAuthorId, verified,
						active);
			default:
				throw new IllegalArgumentException("Unknown contact type");
		}
	}
}
