package org.briarproject.bramble.api.contact;

import org.briarproject.bramble.api.identity.Author;
import org.briarproject.bramble.api.plugin.TransportId;
import org.briarproject.bramble.api.properties.TransportProperties;

import java.util.Map;

public class ContactInfo {
	private final Author author;
	private final Map<TransportId, TransportProperties> properties;
	private final byte[] signature;
	private final long timestamp;
	private final ContactType type;

	public ContactInfo(Author author,
			Map<TransportId, TransportProperties> properties,
			byte[] signature, long timestamp, ContactType type) {
		this.author = author;
		this.properties = properties;
		this.signature = signature;
		this.timestamp = timestamp;
		this.type = type;
	}

	public Author getAuthor() {
		return author;
	}

	public Map<TransportId, TransportProperties> getProperties() {
		return properties;
	}

	public byte[] getSignature() {
		return signature;
	}

	public long getTimestamp() {
		return timestamp;
	}

	public ContactType getType() {
		return type;
	}
}
