package org.briarproject.bramble.api.contact;

import org.briarproject.bramble.api.identity.Author;
import org.briarproject.bramble.api.identity.AuthorId;
import org.briarproject.bramble.api.nullsafety.NotNullByDefault;

import javax.annotation.concurrent.Immutable;

import static org.briarproject.bramble.api.contact.ContactType.MAILBOX_OWNER;

@Immutable
@NotNullByDefault
public class MailboxOwner extends Contact {

	public MailboxOwner(ContactId id,
			Author author,
			AuthorId localAuthorId,
			boolean verified, boolean active) {
		super(id, author, localAuthorId, verified, active);
	}

	@Override
	public ContactType getType() {
		return MAILBOX_OWNER;
	}
}
