package org.briarproject.bramble.api.mailbox;

import org.briarproject.bramble.api.contact.ContactId;
import org.briarproject.bramble.api.plugin.TransportConnectionReader;
import org.briarproject.bramble.api.plugin.TransportConnectionWriter;
import org.briarproject.bramble.api.plugin.TransportId;
import org.briarproject.bramble.api.plugin.duplex.DuplexTransportConnection;
import org.briarproject.bramble.api.transport.StreamContext;

public interface MailboxManager {

	void handleOutgoingContactMailboxConnection(ContactId contactId,
			DuplexTransportConnection connection, TransportId transportId);

	void handleOutgoingPrivateMailboxConnection(ContactId contactId,
			DuplexTransportConnection connection, TransportId transportId);

	/**
	 *  Handle and incoming mailbox owner connection
	 *  NOTE: Before calling the tag MUST be read from the stream!
	 *  (Otherwise we wouldn't know that it's a MailboxOwner connection)
	 */
	void handleIncomingMailboxOwnerConnection(StreamContext ctx,
			TransportId transportId, TransportConnectionReader reader,
			TransportConnectionWriter writer);

	void handleOwnerContactWithoutMailbox(MailboxInfo mailboxInfo);
}
