package org.briarproject.bramble.mailbox.protocol;

import org.briarproject.bramble.api.FormatException;
import org.briarproject.bramble.api.data.BdfList;

public class MailboxRequestSync extends MailboxRequest {
	private byte[] encryptedStream;
	private boolean endOfStream;

	public MailboxRequestSync(byte[] encryptedStream, boolean endOfStream) {
		super(TYPE.SYNC);
		this.encryptedStream = encryptedStream;
		this.endOfStream = endOfStream;
	}

	public MailboxRequestSync(BdfList lst) throws FormatException {
		super(lst);
	}

	@Override
	protected BdfList getRequestBody() {
		return BdfList.of(encryptedStream, endOfStream);
	}

	@Override
	public boolean hasResponse() {
		return false;
	}

	@Override
	public void parseBody(BdfList list) throws FormatException {
		this.encryptedStream = list.getRaw(0);
		this.endOfStream = list.getBoolean(1);
	}

	public byte[] getSyncStream() {
		return encryptedStream;
	}

	public boolean isEndOfStream() {
		return endOfStream;
	}
}
