package org.briarproject.mailbox.android.activity;

import android.app.Activity;

import org.briarproject.mailbox.android.controller.BriarController;
import org.briarproject.mailbox.android.controller.BriarControllerImpl;
import org.briarproject.mailbox.android.controller.DbController;
import org.briarproject.mailbox.android.controller.DbControllerImpl;
import org.briarproject.mailbox.android.login.PasswordController;
import org.briarproject.mailbox.android.login.PasswordControllerImpl;
import org.briarproject.mailbox.android.login.SetupController;
import org.briarproject.mailbox.android.login.SetupControllerImpl;
import org.briarproject.mailbox.android.navdrawer.NavDrawerController;
import org.briarproject.mailbox.android.navdrawer.NavDrawerControllerImpl;

import dagger.Module;
import dagger.Provides;

import static org.briarproject.mailbox.android.BriarService.BriarServiceConnection;

@Module
public class ActivityModule {

	private final BaseActivity activity;

	public ActivityModule(BaseActivity activity) {
		this.activity = activity;
	}

	@ActivityScope
	@Provides
	BaseActivity provideBaseActivity() {
		return activity;
	}

	@ActivityScope
	@Provides
	Activity provideActivity() {
		return activity;
	}

	@ActivityScope
	@Provides
	SetupController provideSetupController(
			SetupControllerImpl setupController) {
		return setupController;
	}

	@ActivityScope
	@Provides
	PasswordController providePasswordController(
			PasswordControllerImpl passwordController) {
		return passwordController;
	}

	@ActivityScope
	@Provides
	protected BriarController provideBriarController(
			BriarControllerImpl briarController) {
		activity.addLifecycleController(briarController);
		return briarController;
	}

	@ActivityScope
	@Provides
	DbController provideDBController(DbControllerImpl dbController) {
		return dbController;
	}

	@ActivityScope
	@Provides
	NavDrawerController provideNavDrawerController(
			NavDrawerControllerImpl navDrawerController) {
		activity.addLifecycleController(navDrawerController);
		return navDrawerController;
	}

	@ActivityScope
	@Provides
	BriarServiceConnection provideBriarServiceConnection() {
		return new BriarServiceConnection();
	}

}
