package org.briarproject.mailbox.android.login;

import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;

import org.briarproject.bramble.api.nullsafety.MethodsNotNullByDefault;
import org.briarproject.bramble.api.nullsafety.ParametersNotNullByDefault;
import org.briarproject.mailbox.R;
import org.briarproject.mailbox.android.activity.ActivityComponent;

import javax.annotation.Nullable;

@MethodsNotNullByDefault
@ParametersNotNullByDefault
public class IntroFragment extends SetupFragment {

	private final static String TAG = IntroFragment.class.getName();

	private Button nextButton;

	public static IntroFragment newInstance() {
		return new IntroFragment();
	}

	@Override
	public View onCreateView(LayoutInflater inflater,
			@Nullable ViewGroup container,
			@Nullable Bundle savedInstanceState) {
		getActivity().setTitle(getString(R.string.setup_title));
		View v = inflater.inflate(R.layout.fragment_setup_intro,
				container, false);
		nextButton = v.findViewById(R.id.next);
		nextButton.setOnClickListener(this);
		return v;
	}

	@Override
	public String getUniqueTag() {
		return TAG;
	}

	@Override
	public void injectFragment(ActivityComponent component) {
		component.inject(this);
	}

	@Override
	public void onClick(View view) {
		setupController.showPasswordFragment();
	}

	@Override
	protected String getHelpText() {
		return null;
	}
}
