package org.briarproject.mailbox.android.viewmodels;

import android.app.Application;
import android.arch.lifecycle.AndroidViewModel;
import android.support.annotation.NonNull;

import org.briarproject.mailbox.android.AndroidComponent;
import org.briarproject.mailbox.android.MailboxApplication;

public abstract class BaseViewModel extends AndroidViewModel {

	public BaseViewModel(
			@NonNull
					Application application) {
		super(application);
		AndroidComponent applicationComponent =
				((MailboxApplication) getApplication())
						.getApplicationComponent();

		ViewModelComponent viewModelComponent =
				DaggerViewModelComponent.builder()
						.androidComponent(applicationComponent)
						.viewModelModule(new ViewModelModule())
						.build();

		injectViewModel(viewModelComponent);

	}

	abstract void injectViewModel(ViewModelComponent viewModelComponent);

}
