package org.briarproject.mailbox.api.android;

import android.app.Notification;

/**
 * Manages notifications for private messages, forum posts, blog posts and
 * introductions.
 */
public interface AndroidNotificationManager {

	String PREF_NOTIFY_SOUND = "notifySound";
	String PREF_NOTIFY_RINGTONE_NAME = "notifyRingtoneName";
	String PREF_NOTIFY_RINGTONE_URI = "notifyRingtoneUri";
	String PREF_NOTIFY_VIBRATION = "notifyVibration";
	String PREF_NOTIFY_LOCK_SCREEN = "notifyLockScreen";

	// Notification IDs
	int ONGOING_NOTIFICATION_ID = 1;
	int FAILURE_NOTIFICATION_ID = 2;
	int REMINDER_NOTIFICATION_ID = 3;

	// Channel IDs
	// Channels are sorted by channel ID in the Settings app, so use IDs
	// that will sort below the main channels such as contacts
	String ONGOING_CHANNEL_ID = "zForegroundService";
	String FAILURE_CHANNEL_ID = "zStartupFailure";
	String REMINDER_CHANNEL_ID = "zSignInReminder";

	// Actions for pending intents
	String ACTION_DISMISS_REMINDER = "dismissReminder";

	Notification getForegroundNotification();

	void updateForegroundNotification(boolean locked);

	void showSignInNotification();

	void clearSignInNotification();

	void blockSignInNotification();
}
